﻿
Namespace Model.Development
    Public Class DEV_TaskSchedule
        Public Sub New()

        End Sub

        Private _ScheduleID As Integer
        Public Property ScheduleID() As Integer
            Get
                Return _ScheduleID
            End Get
            Set(ByVal value As Integer)
                _ScheduleID = value
            End Set
        End Property

        Private _TaskID As Integer
        Public Property TaskID() As Integer
            Get
                Return _TaskID
            End Get
            Set(ByVal value As Integer)
                _TaskID = value
            End Set
        End Property

        Private _TaskName As String
        Public Property TaskName() As String
            Get
                Return _TaskName
            End Get
            Set(ByVal value As String)
                _TaskName = value
            End Set
        End Property

        Private _CreationDate As DateTime
        Public Property CreationDate() As DateTime
            Get
                Return _CreationDate
            End Get
            Set(ByVal value As DateTime)
                _CreationDate = value
            End Set
        End Property

        Private _CreationByID As Integer
        Public Property CreationByID() As Integer
            Get
                Return _CreationByID
            End Get
            Set(ByVal value As Integer)
                _CreationByID = value
            End Set
        End Property

        Private _CreationBy As String
        Public Property CreationBy() As String
            Get
                Return _CreationBy
            End Get
            Set(ByVal value As String)
                _CreationBy = value
            End Set
        End Property

        Private _LastUpdateDate As DateTime
        Public Property LastUpdateDate() As DateTime
            Get
                Return _LastUpdateDate
            End Get
            Set(ByVal value As DateTime)
                _LastUpdateDate = value
            End Set
        End Property

        Private _LastUpdateByID As Integer
        Public Property LastUpdateByID() As Integer
            Get
                Return _LastUpdateByID
            End Get
            Set(ByVal value As Integer)
                _LastUpdateByID = value
            End Set
        End Property

        Private _LastUpdateBy As String
        Public Property LastUpdateBy() As String
            Get
                Return _LastUpdateBy
            End Get
            Set(ByVal value As String)
                _LastUpdateBy = value
            End Set
        End Property

        Private _ScheduleDate As DateTime
        Public Property ScheduleDate() As DateTime
            Get
                Return _ScheduleDate
            End Get
            Set(ByVal value As DateTime)
                _ScheduleDate = value
            End Set
        End Property

        Private _ScheduleByID As Integer
        Public Property ScheduleByID() As Integer
            Get
                Return _ScheduleByID
            End Get
            Set(ByVal value As Integer)
                _ScheduleByID = value
            End Set
        End Property

        Private _ScheduleBy As String
        Public Property ScheduleBy() As String
            Get
                Return _ScheduleBy
            End Get
            Set(ByVal value As String)
                _ScheduleBy = value
            End Set
        End Property

        Private _Description As String
        Public Property Description() As String
            Get
                Return _Description
            End Get
            Set(ByVal value As String)
                _Description = value
            End Set
        End Property

        Private _ScheduleMinutes As Integer
        Public Property ScheduleMinutes() As Integer
            Get
                Return _ScheduleMinutes
            End Get
            Set(ByVal value As Integer)
                _ScheduleMinutes = value
            End Set
        End Property

        Public ReadOnly Property ScheduleTimeSpan() As TimeSpan
            Get
                Return TimeSpan.FromMinutes(_ScheduleMinutes)
            End Get
        End Property

        Public ReadOnly Property ScheduleHoursMinutes() As String
            Get
                Return ScheduleTimeSpan.Hours.ToString & "u" & ScheduleTimeSpan.Minutes.ToString
            End Get
        End Property

        Public Function GetMyClone() As DEV_TaskSchedule
            Dim clone As New DEV_TaskSchedule
            With clone
                .CreationBy = Me.CreationBy
                .CreationByID = Me.CreationByID
                .CreationDate = Me.CreationDate
                .Description = Me.Description
                .LastUpdateBy = Me.LastUpdateBy
                .LastUpdateByID = Me.LastUpdateByID
                .LastUpdateDate = Me.LastUpdateDate
                .ScheduleBy = Me.ScheduleBy
                .ScheduleByID = Me.ScheduleByID
                .ScheduleDate = Me.ScheduleDate
                .ScheduleID = Me.ScheduleID
                .ScheduleMinutes = Me.ScheduleMinutes
                .TaskID = Me.TaskID
                .TaskName = Me.TaskName
            End With
            Return clone
        End Function

        Private _Task As DEV_Task
        Public Property Task() As DEV_Task
            Get
                Return _Task
            End Get
            Set(ByVal value As DEV_Task)
                _Task = value
            End Set
        End Property
        Public ReadOnly Property Task_Project() As String
            Get
                If Not Task Is Nothing Then
                    Return Task.Project
                Else
                    Return ""
                End If
            End Get
        End Property
        Public ReadOnly Property Task_PriorityID() As DEV_Priorities
            Get
                If Not Task Is Nothing Then
                    Return Task.PriorityID
                Else
                    Return DEV_Priorities.Low
                End If
            End Get
        End Property
        Public ReadOnly Property Task_AssignedTo() As String
            Get
                If Not Task Is Nothing Then
                    Return Task.AssignedTo
                Else
                    Return ""
                End If
            End Get
        End Property
        Public ReadOnly Property Task_DepartmentID() As Integer
            Get
                If Not Task Is Nothing Then
                    Return Task.DepartmentID
                Else
                    Return 0
                End If
            End Get
        End Property
        Public ReadOnly Property Task_StateID() As DEV_States
            Get
                If Not Task Is Nothing Then
                    Return Task.StateID
                Else
                    Return 0
                End If
            End Get
        End Property
        Public ReadOnly Property Task_PercentComplete() As Integer
            Get
                If Not Task Is Nothing Then
                    Return Task.PercentComplete
                Else
                    Return 0
                End If
            End Get
        End Property
        Public ReadOnly Property Task_WorkTotalFormat() As String
            Get
                If Not Task Is Nothing Then
                    Return Task.WorkTotalFormat
                Else
                    Return ""
                End If
            End Get
        End Property
        Public ReadOnly Property Task_ScheduleTotalFormat() As String
            Get
                If Not Task Is Nothing Then
                    Return Task.ScheduleTotalFormat
                Else
                    Return ""
                End If
            End Get
        End Property

        ' Volgende 3 properties worden gebruikt bij het maandoverzicht in project management,
        ' in combinatie met worklogs (DEV_WorkLog): vandaar gelijke naamgeving van velden noodzakelijk
        Public ReadOnly Property ItemBy() As String
            Get
                Return ScheduleBy
            End Get
        End Property
        Public ReadOnly Property ItemDate() As DateTime
            Get
                Return ScheduleDate
            End Get
        End Property
        Public ReadOnly Property ItemTime() As String
            Get
                Return ScheduleHoursMinutes
            End Get
        End Property

    End Class
End Namespace
